Skip to main content
`Ctrl`+`K`

# PetscOptionsReal

Gets a `PetscReal` value for a particular option in the database.

## Synopsis

    #include <petscoptions.h>
    PetscErrorCode PetscOptionsReal(const char opt[], const char text[], const char man[], PetscReal currentvalue, PetscReal *value, PetscBool *set)

Logically Collective on the communicator passed in `PetscOptionsBegin()`

## Input Parameters

- opt - option name

- text - short string that describes the option

- man - manual page with additional information on option

- currentvalue - the current value; caller is responsible for setting this value correctly. Normally this is done with either

                     PetscOptionsReal(..., obj->value,&obj->value,...) or
                     value = defaultvalue
                     PetscOptionsReal(..., value,&value,&set);
                     if (set) {

## Output Parameters

- value - the value to return

- set - `PETSC_TRUE` if found, else `PETSC_FALSE`

## Notes

If the user does not supply the option at all `value` is NOT changed. Thus you should ALWAYS initialize `value` if you access it without first checking that `set` is `PETSC_TRUE`.

The `currentvalue` passed into this routine does not get transferred to the output `value` variable automatically.

Must be used between a `PetscOptionsBegin()` and a `PetscOptionsEnd()`

## See Also

`PetscOptionsGetReal()`, `PetscOptionsHasName()`, `PetscOptionsGetString()`, `PetscOptionsGetInt()`, `PetscOptionsGetIntArray()`, `PetscOptionsGetRealArray()`, `PetscOptionsGetBool()`, `PetscOptionsInt()`, `PetscOptionsString()`, `PetscOptionsReal()`, `PetscOptionsBool()`, `PetscOptionsName()`, `PetscOptionsBegin()`, `PetscOptionsEnd()`, `PetscOptionsHeadBegin()`, `PetscOptionsStringArray()`, `PetscOptionsRealArray()`, `PetscOptionsScalar()`, `PetscOptionsBoolGroupBegin()`, `PetscOptionsBoolGroup()`, `PetscOptionsBoolGroupEnd()`, `PetscOptionsFList()`, `PetscOptionsEList()`, `PetscOptionsBoundedReal()`, `PetscOptionsRangeReal()`

## Level

beginner

## Location

include/petscoptions.h

## Examples

src/ksp/ksp/tutorials/ex74.c
src/ksp/ksp/tutorials/ex73.c
src/ksp/ksp/tutorials/ex56.c
src/dm/impls/plex/tutorials/ex9.c
src/ksp/ksp/tutorials/ex29.c
src/ksp/ksp/tutorials/ex36.cxx
src/snes/tutorials/ex46.c
src/ksp/ksp/tutorials/ex35.cxx
src/dm/impls/plex/tutorials/ex13.c
src/snes/tutorials/ex31.c

Index of all Sys routines
Table of Contents for all manual pages
Index of all manual pages